Package: lfda
Type: Package
Title: Local Fisher Discriminant Analysis
Version: 1.1.3
Date: 2019-07-31
Authors@R: c(
  person("Yuan", "Tang", role = c("aut", "cre"),
         email = "terrytangyuan@gmail.com",
         comment = c(ORCID = "0000-0001-5243-233X")),
  person("Wenxuan", "Li", role = c("ctb")),
  person("Nan", "Xiao", role = c("ctb", "cph")),
  person("Zachary", "Deane-Mayer", role = c("ctb")))
URL: https://github.com/terrytangyuan/lfda
BugReports: https://github.com/terrytangyuan/lfda/issues
Maintainer: Yuan Tang <terrytangyuan@gmail.com>
License: MIT + file LICENSE
Description: Functions for performing and visualizing Local Fisher Discriminant
    Analysis(LFDA), Kernel Fisher Discriminant Analysis(KLFDA), and Semi-supervised
    Local Fisher Discriminant Analysis(SELF).
Depends: R (>= 3.1.0)
Imports: plyr, grDevices, rARPACK
Suggests: testthat, rgl
RoxygenNote: 6.1.0
NeedsCompilation: no
Packaged: 2019-07-31 16:46:28 UTC; yuan.tang
Author: Yuan Tang [aut, cre] (<https://orcid.org/0000-0001-5243-233X>),
  Wenxuan Li [ctb],
  Nan Xiao [ctb, cph],
  Zachary Deane-Mayer [ctb]
Repository: CRAN
Date/Publication: 2019-07-31 17:10:02 UTC
Built: R 4.6.0; ; 2026-04-27 07:03:34 UTC; unix

Package: lfda
Type: Package
Title: Local Fisher Discriminant Analysis
Version: 1.1.3
Date: 2019-07-26
Author: Yuan Tang. Contributions from Wenxuan Li, Nan Xiao and Zachary Deane-Mayer.
URL: https://github.com/terrytangyuan/lfda
BugReports: https://github.com/terrytangyuan/lfda/issues
Maintainer: Yuan Tang <terrytangyuan@gmail.com>
License: MIT + file LICENSE
Description: Functions for performing and visualizing Local Fisher Discriminant
    Analysis(LFDA), Kernel Fisher Discriminant Analysis(KLFDA), and Semi-supervised
    Local Fisher Discriminant Analysis(SELF).
Depends: R (>= 3.1.0)
Imports: plyr, grDevices, rARPACK
Suggests: testthat, rgl
RoxygenNote: 6.1.0
Built: R 4.4.0; ; 2024-05-03 03:23:49 UTC; unix

context("Test klfda functionalities")

data(iris)

test_that("klfda works correctly for different metrics on the data transformed by kmatrixGauss()", {
  k <- kmatrixGauss(iris[, -5])
  y <- iris[, 5]
  r <- 3
  result <- klfda(k, y, r, metric = "plain")
  expect_equal(dim(result$T), c(150, 3))
  expect_equal(dim(result$Z), c(150, 3))

  result <- klfda(k, y, r, metric = "weighted")
  expect_equal(dim(result$T), c(150, 3))
  expect_equal(dim(result$Z), c(150, 3))

  result <- klfda(k, y, r, metric = "orthonormalized")
  expect_equal(dim(result$T), c(150, 3))
  expect_equal(dim(result$Z), c(150, 3))
})

context("Test lfda functionalities")

data(iris)

test_that("lfda works correctly on different metrics", {
  k <- iris[, -5]
  y <- iris[, 5]
  r <- 3
  result <- lfda(k, y, r, metric = "plain")
  expect_equal(dim(result$T), c(4, 3))
  expect_equal(dim(result$Z), c(150, 3))

  result <- lfda(k, y, r, metric = "weighted")
  expect_equal(dim(result$T), c(4, 3))
  expect_equal(dim(result$Z), c(150, 3))

  result <- lfda(k, y, r, metric = "orthonormalized")
  expect_equal(dim(result$T), c(4, 3))
  expect_equal(dim(result$Z), c(150, 3))

  expect_error(lfda(k, y, r, metric = "plain", knn = 10000))

  # case when r = d
  result <- lfda(k, y, r = 4, metric = "plain")
  expect_equal(dim(result$T), c(4, 4))
  expect_equal(dim(result$Z), c(150, 4))
})

test_that("S3 methods on produced lfda model have the correct behaviors", {
  k <- iris[, -5]
  y <- iris[, 5]
  r <- 3

  model <- lfda(k, y, r = 4, metric = "plain")
  expect_equal(dim(predict(model, iris[, -5])), c(150, 4))
  expect_error(predict(model, iris[, -5], "wrongType"))
  expect_error(predict(model))

  expect_equal(length(capture.output(print(model))), 20)
})

context("Test visualization on different lfda models")

data(iris)

test_that("Visualization on klfda model works", {
  skip_on_cran()
  skip_if_not_installed("rgl")
  k <- kmatrixGauss(iris[, -5])
  y <- iris[, 5]
  r <- 3
  result <- klfda(k, y, r, metric = "plain")
  options(rgl.useNULL = TRUE) # deal with rgl in Travis
  expect_silent(plot(result, iris[, 5]))
})

test_that("Visualiztion on lfda model works", {
  skip_on_cran()
  skip_if_not_installed("rgl")
  k <- iris[, -5]
  y <- iris[, 5]
  r <- 3
  result <- lfda(k, y, r, metric = "plain")
  options(rgl.useNULL = TRUE) # deal with rgl in Travis
  expect_silent(plot(result, iris[, 5]))
})

test_that("Visualization on self model works", {
  skip_on_cran()
  skip_if_not_installed("rgl")
  X <- iris[, -5]
  Y <- iris[, 5]
  r <- 3
  result <- self(X, Y, beta = 0.1, r = 3, metric = "plain")
  options(rgl.useNULL = TRUE) # deal with rgl in Travis
  expect_silent(plot(result, iris[, 5]))
})

test_that("Exceptions are caught in visualization function", {
  skip_on_cran()
  skip_if_not_installed("rgl")
  k <- iris[, -5]
  y <- iris[, 5]
  r <- 3
  result <- lfda(k, y, r, metric = "plain")
  options(rgl.useNULL = TRUE) # deal with rgl in Travis
  plot(result, iris[, 5], cleanText = TRUE)
  expect_error(plot(result, iris[, 1:5]))
  expect_error(plot(result, iris[1:10, 5]))
  expect_error(plot(result, iris[, 5], cleanText = 3))
  plot(result, as.character(iris[, 5]))
  expect_warning(plot(lfda(k, y, 4, metric = "plain"), y))
  expect_error(plot(lfda(k, y, 2, metric = "plain"), y))
})

context("Test the helper functions used in lfda implementations")

data(iris)

test_that("kmatrixGauss() calculates the Gaussian kernel correctly", {
  result <- kmatrixGauss(iris[, -5])
  expect_equal(dim(result), c(150, 150))
})

test_that("repmat() calculates the matrix after negative one half power correctly", {
  result <- repmat(matrix(c(1, 2, 3, 4, 5, 6), nrow = 3, ncol = 2, byrow = TRUE), 2, 3)
  expect_equal(dim(result), c(6, 6))
})

test_that("%^% symbol generates an N-by-M tiling copies of original matrix correctly", {
  mat <- matrix(c(1, 2, 3, 4), nrow = 2, ncol = 2, byrow = TRUE)
  expect_equal(dim(mat %^% 3), c(2, 2))
  mat <- matrix(c(1, 2, 3, 4, 5, 6), nrow = 3, ncol = 2, byrow = TRUE)
  expect_error(mat %^% 3)
})

context("self")

data(iris)

test_that("self works", {
  X <- iris[, -5]
  Y <- iris[, 5]
  r <- 3
  result <- self(X, Y, beta = 0.1, r = 3, metric = "plain")
  expect_equal(dim(result$T), c(4, 3))
  expect_equal(dim(result$Z), c(150, 3))

  suppressWarnings(self(X, Y, beta = 0.1, r = 3, metric = "weighted"))
  result <- self(X, Y, beta = 0.1, r = 3, metric = "orthonormalized")
  expect_equal(dim(result$T), c(4, 3))
  expect_equal(dim(result$Z), c(150, 3))

  # case when r = d
  result <- self(X, Y, beta = 0.1, r = 4, metric = "plain")
  expect_equal(dim(result$T), c(4, 4))
  expect_equal(dim(result$Z), c(150, 4))

  # case when one label only has 4 obs, which is less than the default minObsPerLabel = 5
  expect_error(capture.output(
    self(iris[c(1:4, 51:dim(iris)[1]), -5], iris[c(1:4, 51:dim(iris)[1]), 5],
      beta = 0.1, r = 3, metric = "plain"
    )
  ))

  model <- self(X, Y, beta = 0.1, r = 3, metric = "plain")
  predict(model, iris[, -5])
  expect_error(predict(model, iris[, -5], "wrongType"))
  expect_error(predict(model))
  capture.output(print(model))
})
